include("helval.jl")

x = helval_startp()
f = helval

# il numero delle variabili è dato dalla lunghezza
# del vettore punto iniziale x
n = length(x)  

# la matrice delle direzioni di ricerca è D = [I -I]
# il numero di colonne di D è m = 2*n
D = [eye(n,n) -eye(n,n)]
m = size(D,2)

Delta = 1.0
tol   = 1.e-3
maxit = 1000
k     = 0
fx    = f(x)
nf    = 1

@printf("+-----------------------------------------+\n")
@printf("|         Nuovo metodo 1 (CSmod1)         |\n")
@printf("+-----------------------------------------+\n")

@printf("   k     nf      fx           Delta\n")
while (k <= maxit) && (Delta > tol)
      k  = k+1
      y  = copy(x)
      fy = f(x)
      for i = 1:m
      	  d  = D[:,i]
      	  ft = f(y+Delta*d)
	  nf = nf+1
	  if ft < fy
	     y  = y+Delta*d
	     fy = ft
	  end
      end
      if fy < fx
      	 x  = y
	 fx = fy
      else
	 Delta = Delta/2
      end
      @printf("%4d %6d %13.6e %13.6e\n",k,nf,fx,Delta)
end

nothing